#ifndef CONFIG_LOADER_H
#define CONFIG_LOADER_H

#include <string>

#define OPT_CFG_REF_UNIT_KEY    "ref_unit"
#define OPT_CFG_OFFSET_KEY      "offset"

namespace config_loader {
    /**
     * @brief This funciton loads main configuration. _ini symobolizes that the expected format is .ini
     * 
     * @param cfg_path config file path
     * @return int 0 on success
     */
    int load_main_config_ini(const char* cfg_path);
    /**
     * @brief Checks if optional config exists
     * 
     * @param cfg_path config file path
     * @return int 0 on succes
     */
    int exist_opt_config(const char* cfg_path);
    /**
     * @brief Loads the optional config
     * 
     * @param cfg_path config file path
     * @return int 0 on succes
     */
    int load_opt_config(const char* cfg_path);
    /**
     * @brief This is used to replace a values in optional config.
     * 
     * @param cfg_path config file path
     * @param key which value is changed
     * @param value to be set
     * @return int 0 on success, 1 if config couldn't be opened
     */
    int replace_opt_in_opt_config(const char* cfg_path, std::string key, std::string value);
};

#endif