#ifndef GUI_DIRECT_H
#define GUI_DIRECT_H

#include "gui_element.h"
#include "app_workspace.h"

/**
 * @brief This is a special element, that doesn't wrap any ImGui function. This is used 
 * to render ImGui directly through calling a function.
 * 
 */
class gui_direct : public gui_element {
    private:
        void (*func)();

    public:
        /**
         * @brief Construct a new gui direct object
         * 
         * @param func that has ImGui logic
         */
        gui_direct(void (*func)());

        /** Override of parent function, that is required, because it does the actual rendering of the element */
        void render_element();
};

#endif