#ifndef GUI_ELEMENT_H
#define GUI_ELEMENT_H

/**
 * @brief Paren class for other gui elements.
 * 
 */
class gui_element {
    protected:
        int width = -1;
        int x = -1, y = -1;
        
        // if this is init, allows internally refresh next frame elements
        bool *refresh_screen = nullptr;
    
    public:
        // reimplement following as attributes in screen_manager instead
        // bool highlighted = false;
        // bool selected = false;
        int index = -1;

        /** Allows to set refresh screen flag. When this is set, the screen elements are reloaded */
        void set_refresh_screen(bool *refresh_flag);
        /** This function calls the element rendering. This is required to be overriden for the element to be rendered */
        virtual void render_element();
};

#endif