#ifndef GUI_LABEL_H
#define GUI_LABEL_H

#include "gui_element.h"
#include "app_workspace.h"

/**
 * @brief This is a wrapper for ImGui Text which serves as unchangeble label.
 * 
 */
class gui_label : public gui_element {
    private:
        const char *label = nullptr;
        app_workspace_ns::font_size font_size = app_workspace_ns::font_size::NORMAL_FONT;

    public:
        /**
         * @brief Construct a new gui label object
         * 
         * @param label is required... since it's.. u'know... a label...
         * @param x if set to -1, isn't used
         * @param y if set to -1, isn't used
         * @param width if set to -1, isn't used
         * @param font_size Default font size is NORMAL
         */
        gui_label(const char *label, int x = -1, int y = -1, int width = -1,
                app_workspace_ns::font_size font_size = app_workspace_ns::font_size::NORMAL_FONT);
        ~gui_label();

        /** Override of parent function, that is required, because it does the actual rendering of the element */
        void render_element();
        /** Changes label of the instance of this element */
        void set_label(const char* label);
};

#endif