#ifndef LOCALISATION_H
#define LOCALISATION_H

/**
 * @brief Get the localized text object
 * 
 * Not doing any eror cheking. 
 * Programmer MUST ensure all languages are in switch and every key has a translation in map.
 * 
 * @param key string key
 * @return const char* 
 */
const char* get_localized_text(const char *key);

/**
 * @brief Loads default language dictionary
 * 
 * @return int 
 */
int load_default_dict();

/**
 * @brief Loads current language dictionary. This could be called
 * with an action during runtime to change the app language. 
 * 
 * @return int 
 */
int load_current_dict();

#endif