#include "gui_selectable.h"


gui_selectable::gui_selectable(const char *label, int index, int *selector, void (*callback)(),
                               int width, int height, ImGuiSelectableFlags flags)
{
    this->label = label;
    this->index = index;
    this->selector = selector;
    this->width = (width <= 0 ? 0 : width);
    this->height = (height <= 0 ? 0 : height);
    this->callback = callback;
    this->flags = flags;
    // "label##i" - is to ensure unique ImGuiID, but label should already be unique
    this->inner_label = std::string(this->label) + "##" + std::to_string(this->index);
}

void gui_selectable::render_element() {
    gui_element::render_element();

    ImVec2 size((float) width, (float) height);
    // if (ImGui::Selectable(this->inner_label.c_str(), this->index == *(this->selector), this->flags, size)) {
    if (ImGui::Selectable(this->inner_label.c_str(), false, this->flags, size)) { // false - not highlighting selected element
        *(this->selector) = this->index;

        if (this->callback != nullptr)
            this->callback();
    }
}