-- Create Table Measurements
-- measuring length in us
-- values MEDIUMBLOD <= 16,777,215B - stores C doubles as binary, normalized data from hx
--      (for raw data reference unit and offset would have to be saved)
-- values, medians and avarages are saved in g (double of gram) this is because hx library reads in g
--
-- measurement_part INT(8) NOT NULL DEFAULT 1, thought about adding this column, but it isnt need
-- because either created_at/ measuring_start can be used to order parts of the measuring, use both or choose one?
-- column added, because of time precision (altough samples are saved about every 60 secs)
CREATE TABLE IF NOT EXISTS cs_measurements (
    id INT(8) AUTO_INCREMENT PRIMARY KEY,
    status INT(1) NOT NULL DEFAULT 1,
    measurement_number INT(8) NOT NULL,
    measurement_part INT(8) NOT NULL DEFAULT 1,
    measuree_id INT(8) NOT NULL,
    measurer_id INT(8) NOT NULL,
    measuring_length INT(8),
    measuring_start TIMESTAMP NOT NULL,
    measuring_end   TIMESTAMP NOT NULL,
    description     VARCHAR(2048),
    value_length    INT(1) DEFAULT 8,
    value_count     INT(8),
    m_values        MEDIUMBLOB,
    x_val_median    DOUBLE NOT NULL,
    x_val_avg       DOUBLE NOT NULL,
    all_val_median  DOUBLE NOT NULL,
    all_val_avg     DOUBLE NOT NULL,
    created_at TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
    CONSTRAINT FK_measuree_user FOREIGN KEY (measuree_id) REFERENCES cs_users(id),
    CONSTRAINT FK_measuring_user FOREIGN KEY (measurer_id) REFERENCES cs_users(id)
);